import matplotlib.pyplot as plt
from matplotlib.backends.backend_pdf import PdfPages
import torch

def show_MnM_images(x_image=None, x_merlin=None, s_merlin=None, x_morgana=None, s_morgana=None, n_samples = 8, pic_pdf = None, show_pics = False):

    n_samples = min(x_image.shape[0], n_samples)
    fig, ax = plt.subplots(5, n_samples)
    for idx in range(n_samples):
        ax[0, idx].imshow(x_image[idx].cpu().squeeze(), vmin=0, vmax=1)
        ax[1, idx].imshow(x_merlin[idx].cpu().squeeze(), vmin=0, vmax=1)
        ax[2, idx].imshow(s_merlin[idx].cpu().squeeze(), vmin=0, vmax=1)
        ax[3, idx].imshow(x_morgana[idx].cpu().squeeze(), vmin=0, vmax=1)
        ax[4, idx].imshow(s_morgana[idx].cpu().squeeze(), vmin=0, vmax=1)
    fig.set_size_inches(3*n_samples, 8)
    if show_pics == True:
        plt.show()
    else:
        pic_pdf.savefig(fig)
        
"""
Display multi channel images
"""
def show_MnM_images_MC(x_image=None, x_merlin=None, s_merlin=None, x_morgana=None, s_morgana=None, n_samples = 8, pic_pdf = None, show_pics = False):

    n_samples = min(x_image.shape[0], n_samples)
    fig, ax = plt.subplots(5, n_samples)
    for idx in range(n_samples):
        ax[0, idx].imshow(torch.permute(x_image[idx].cpu().squeeze(),(1,2,0)), vmin=0, vmax=1)
        ax[1, idx].imshow(torch.permute(x_merlin[idx].cpu().squeeze(),(1,2,0)), vmin=0, vmax=1)
        ax[2, idx].imshow(s_merlin[idx].cpu().squeeze(), vmin=0, vmax=1)
        ax[3, idx].imshow(torch.permute(x_morgana[idx].cpu().squeeze(),(1,2,0)), vmin=0, vmax=1)
        ax[4, idx].imshow(s_morgana[idx].cpu().squeeze(), vmin=0, vmax=1)
    fig.set_size_inches(3*n_samples, 8)
    if show_pics == True:
        plt.show()
    else:
        pic_pdf.savefig(fig)
    
    
    
def show_example_images(x_image=None, y_target=None, n_samples=4, trainLoader=None):
    if x_image is None:
        x_input, y_target = next(iter(trainLoader))
        x_image = x_input.select(dim=1, index=0)
        
    fig, ax = plt.subplots(n_samples)
    for idx in range(n_samples):
        ax[idx].imshow(x_image[idx].cpu().squeeze(), vmin=0, vmax=1)
        print(y_target[idx].item())
    fig.set_size_inches(4, 2*n_samples)
    plt.show()